## kfreebsd-10 10.3~svn300087

=== sys/boot/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

.if ${MK_FORTH} != "no"
# Build the add-in FORTH interpreter.
SUBDIR+=		ficl
SUBDIR+=		forth
.endif

.include <bsd.arch.inc.mk>

# Pick the machine-dependent subdir based on the target architecture.
ADIR=			${MACHINE:S/powerpc64/powerpc/}
.if exists(${.CURDIR}/${ADIR}/.)
SUBDIR+=		${ADIR}
.endif

.include <bsd.subdir.mk>

=== sys/kern/Makefile ===
#	@(#)Makefile	8.2 (Berkeley) 3/21/94
# $FreeBSD$

# Makefile for init_sysent

all:
	@echo "make sysent only"

sysent: init_sysent.c syscalls.c ../sys/syscall.h ../sys/syscall.mk \
../sys/sysproto.h

init_sysent.c syscalls.c systrace_args.c ../sys/syscall.h \
../sys/syscall.mk ../sys/sysproto.h: makesyscalls.sh syscalls.master \
capabilities.conf
	-mv -f init_sysent.c init_sysent.c.bak
	-mv -f syscalls.c syscalls.c.bak
	-mv -f systrace_args.c systrace_args.c.bak
	-mv -f ../sys/syscall.h ../sys/syscall.h.bak
	-mv -f ../sys/syscall.mk ../sys/syscall.mk.bak
	-mv -f ../sys/sysproto.h ../sys/sysproto.h.bak
	sh makesyscalls.sh syscalls.master

=== sys/modules/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

SUBDIR_PARALLEL=

# Modules that include binary-only blobs of microcode should be selectable by
# MK_SOURCELESS_UCODE option (see below).

SUBDIR=	\
	${_3dfx} \
	${_3dfx_linux} \
	${_aac} \
	${_aacraid} \
	accf_data \
	accf_dns \
	accf_http \
	acl_nfs4 \
	acl_posix1e \
	${_acpi} \
	ae \
	${_aesni} \
	age \
	${_agp} \
	aha \
	${_ahb} \
	ahci \
	${_aic} \
	aic7xxx \
	aio \
	alc \
	ale \
	alq \
	${_amdsbwd} \
	${_amdtemp} \
	amr \
	${_an} \
	${_aout} \
	${_apm} \
	${_arcmsr} \
	${_arcnet} \
	${_asmc} \
	${_asr} \
	ata \
	ath \
	ath_pci \
	${_autofs} \
	${_auxio} \
	${_bce} \
	bfe \
	bge \
	${_bxe} \
	${_bios} \
	${_bktr} \
	${_bm} \
	bridgestp \
	bwi \
	bwn \
	cam \
	${_canbepm} \
	${_canbus} \
	${_cardbus} \
	${_carp} \
	cas \
	${_cbb} \
	cc \
	cd9660 \
	cd9660_iconv \
	${_ce} \
	${_cfi} \
	${_ciss} \
	${_cm} \
	${_cmx} \
	${_coff} \
	${_coretemp} \
	${_cp} \
	${_cpsw} \
	${_cpuctl} \
	${_cpufreq} \
	${_crypto} \
	${_cryptodev} \
	${_cs} \
	${_ct} \
	${_ctau} \
	ctl \
	${_cxgb} \
	${_cxgbe} \
	dc \
	dcons \
	dcons_crom \
	de \
	${_dpms} \
	${_dpt} \
	${_drm} \
	${_drm2} \
	${_dtrace} \
	dummynet \
	${_ed} \
	${_elink} \
	${_em} \
	en \
	${_ep} \
	${_epic} \
	esp \
	${_et} \
	${_ex} \
	${_exca} \
	${_ext2fs} \
	${_fatm} \
	fdc \
	fdescfs \
	${_fe} \
	${_filemon} \
	firewire \
	firmware \
	fuse \
	${_fxp} \
	gem \
	geom \
	${_glxiic} \
	${_glxsb} \
	hatm \
	hifn \
	hme \
	${_hpt27xx} \
	${_hptiop} \
	${_hptmv} \
	${_hptnr} \
	${_hptrr} \
	hwpmc \
	${_hyperv} \
	${_i2c} \
        ${_ibcore} \
	${_ibcs2} \
	${_ichwd} \
	${_ida} \
	${_ie} \
	if_bridge \
	if_disc \
	if_edsc \
	if_ef \
	if_epair \
	if_faith \
	${_if_gif} \
	${_if_gre} \
	${_if_me} \
	if_lagg \
	${_if_ndis} \
	if_stf \
	if_tap \
	if_tun \
	if_vlan \
	if_vxlan \
	${_igb} \
	${_iir} \
	${_imgact_binmisc} \
	${_io} \
        ${_ipoib} \
	${_ipdivert} \
	${_ipfilter} \
	${_ipfw} \
	ipfw_nat \
	${_ipmi} \
	ip6_mroute_mod \
	ip_mroute_mod \
	${_ips} \
	${_ipw} \
	${_ipwfw} \
	${_isci} \
	isp \
	${_ispfw} \
	${_iwi} \
	${_iwifw} \
	${_iwn} \
	${_iwnfw} \
	${_ix} \
	${_ixv} \
	${_ixgb} \
	${_ixgbe} \
	${_ixl} \
	${_ixlv} \
	jme \
	joy \
	kbdmux \
	kgssapi \
	kgssapi_krb5 \
	khelp \
	krpc \
	ksyms \
	le \
	lge \
	libalias \
	libiconv \
	libmbpool \
	libmchain \
	${_lindev} \
	${_linprocfs} \
	${_linsysfs} \
	${_linux} \
	${_linux_common} \
	${_linux64} \
	lmc \
	lpt \
	mac_biba \
	mac_bsdextended \
	mac_ifoff \
	mac_lomac \
	mac_mls \
	mac_none \
	mac_partition \
	mac_portacl \
	mac_seeotheruids \
	mac_stub \
	mac_test \
	malo \
	mcd \
	md \
	mem \
	mfi \
	mii \
	mlx \
	${_mlx4} \
	${_mlx4ib} \
	${_mlxen} \
	${_mlx5} \
	${_mlx5en} \
	${_mly} \
	mmc \
	mmcsd \
	mpr \
	mps \
	mpt \
	mqueue \
	mrsas \
	msdosfs \
	msdosfs_iconv \
	${_mse} \
	msk \
	${_mthca} \
	mvs \
	mwl \
	${_mwlfw} \
	mxge \
	my \
	${_nandfs} \
	${_nandsim} \
	${_ncp} \
	${_ncv} \
	${_ndis} \
	netfpga10g \
	${_netgraph} \
	${_nfe} \
	nfs_common \
	nfscl \
	nfsclient \
	nfscommon \
	nfsd \
	nfslock \
	nfslockd \
	nfsserver \
	nfssvc \
	nge \
	nmdm \
	${_nsp} \
	nullfs \
	${_ntb} \
	${_nvd} \
	${_nve} \
	${_nvme} \
	${_nvram} \
	${_nxge} \
	${_opensolaris} \
	oce \
	${_padlock} \
	patm \
	${_pccard} \
	${_pcfclock} \
	pcn \
	${_pf} \
	${_pflog} \
	${_pfsync} \
	plip \
	${_pmc} \
	${_pms} \
	ppbus \
	ppc \
	ppi \
	pps \
	procfs \
	pseudofs \
	${_pst} \
	pty  \
	puc \
	${_qlxge} \
	${_qlxgb} \
	${_qlxgbe} \
	ral \
	${_ralfw} \
	${_random} \
	rc4 \
	${_rdma} \
	re \
	reiserfs \
	rl \
	${_s3} \
	${_safe} \
	${_sbni} \
	scc \
	scd \
	${_scsi_low} \
	sdhci \
	sdhci_pci \
	sem \
	send \
	${_sf} \
	${_sfxge} \
	sge \
	siba_bwn \
	siftr \
	siis \
	sis \
	sk \
	${_smbfs} \
	${_sn} \
	${_snc} \
	snp \
	${_sound} \
	${_speaker} \
	${_splash} \
	${_sppp} \
	ste \
	${_stg} \
	stge \
	${_streams} \
	${_svr4} \
	${_sym} \
	${_syscons} \
	sysvipc \
	${_ti} \
	tl \
	tmpfs \
	${_toecore} \
	${_tpm} \
	trm \
	${_twa} \
	twe \
	tws \
	tx \
	${_txp} \
	uart \
	ubsec \
	udf \
	udf_iconv \
	ufs \
	unionfs \
	usb \
	utopia \
	${_vesa} \
	${_virtio} \
	vge \
	${_viawd} \
	vkbd \
	${_vmm} \
	${_vmware} \
	${_vpo} \
	vr \
	vte \
	vx \
	${_vxge} \
	wb \
	${_wbwd} \
	${_wi} \
	wlan \
	wlan_acl \
	wlan_amrr \
	wlan_ccmp \
	wlan_rssadapt \
	wlan_tkip \
	wlan_wep \
	wlan_xauth \
	${_wpi} \
	${_wpifw} \
	${_x86bios} \
	${_xe} \
	xl \
	${_zfs} \
	zlib \

.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
_filemon=	filemon
_imgact_binmisc=	imgact_binmisc
_vmware=	vmware
.endif

.if ${MACHINE_CPUARCH} != "powerpc" && ${MACHINE_CPUARCH} != "arm" && \
	${MACHINE_CPUARCH} != "mips"
_syscons=	syscons
_vpo=		vpo
.endif

.if ${MACHINE_CPUARCH} != "arm" && ${MACHINE_CPUARCH} != "mips"
# no BUS_SPACE_UNSPECIFIED
# No barrier instruction support (specific to this driver)
_sym=		sym
# intr_disable() is a macro, causes problems
.if ${MK_SOURCELESS_UCODE} != "no"
_cxgb=		cxgb
.endif
.endif

.if ${MK_SOURCELESS_UCODE} != "no" && ${MACHINE_CPUARCH} != "arm" && \
	${MACHINE_ARCH:C/mips(el)?/mips/} != "mips" && \
	${MACHINE_ARCH} != "powerpc"
_cxgbe=		cxgbe
.endif

.if ${MK_AUTOFS} != "no" || defined(ALL_MODULES)
_autofs=	autofs
.endif

.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
.if exists(${.CURDIR}/../opencrypto)
_crypto=	crypto
_cryptodev=	cryptodev
.endif
.if exists(${.CURDIR}/../crypto)
_random=	random
.endif
.endif

.if (${MK_INET_SUPPORT} != "no" || ${MK_INET6_SUPPORT} != "no") || \
	defined(ALL_MODULES)
_carp=	carp
_toecore=	toecore
_if_gif=	if_gif
_if_gre=	if_gre
.endif

.if ${MK_INET_SUPPORT} != "no" || defined(ALL_MODULES)
_if_me=		if_me
.endif

.if ${MK_IPFILTER} != "no" || defined(ALL_MODULES)
_ipfilter=	ipfilter
.endif

.if ${MK_INET_SUPPORT} != "no" || defined(ALL_MODULES)
_ipdivert=	ipdivert
_ipfw=		ipfw
.endif

.if ${MK_ISCSI} != "no" || defined(ALL_MODULES)
SUBDIR+=	iscsi
SUBDIR+=	iscsi_initiator
.endif

.if ${MK_NAND} != "no" || defined(ALL_MODULES)
_nandfs=	nandfs
_nandsim=	nandsim
.endif

.if ${MK_NETGRAPH} != "no" || defined(ALL_MODULES)
_netgraph=	netgraph
.endif

.if (${MK_PF} != "no" && (${MK_INET_SUPPORT} != "no" || \
	${MK_INET6_SUPPORT} != "no")) || defined(ALL_MODULES)
_pf=		pf
_pflog=		pflog
.if ${MK_INET_SUPPORT} != "no"
_pfsync=	pfsync
.endif
.endif

.if ${MK_SOURCELESS_UCODE} != "no"
_bce=		bce
_fatm=		fatm
_fxp=		fxp
_ispfw=		ispfw
_mwlfw=		mwlfw
_ralfw=		ralfw
_sf=		sf
_sn=		sn
_ti=		ti
_txp=		txp
.endif

.if ${MACHINE_CPUARCH} == "i386"
# XXX some of these can move to the general case when de-i386'ed
# XXX some of these can move now, but are untested on other architectures.
_3dfx=		3dfx
_3dfx_linux=	3dfx_linux
_agp=		agp
_aic=		aic
_an=		an
_aout=		aout
_apm=		apm
_arcnet=	arcnet
_bktr=		bktr
_bxe=		bxe
_cardbus=	cardbus
_cbb=		cbb
.if ${MK_SOURCELESS_UCODE} != "no"
_ce=		ce
.endif
_coff=		coff
.if ${MK_SOURCELESS_UCODE} != "no"
_cp=		cp
.endif
_cpuctl=	cpuctl
_cpufreq=	cpufreq
_cs=		cs
_dpms=		dpms
_drm=		drm
_drm2=		drm2
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_dtrace=	dtrace
.endif
_ed=		ed
_elink=		elink
_em=		em
_ep=		ep
_et=		et
_exca=		exca
_ext2fs=	ext2fs
_fe=		fe
_glxiic=	glxiic
_glxsb=		glxsb
_i2c=		i2c
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ibcore=        ibcore
.endif
_ibcs2=		ibcs2
_ie=		ie
_if_ndis=	if_ndis
_igb=		igb
_io=		io
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ipoib=         ipoib
.endif
_lindev=	lindev
_linprocfs=	linprocfs
_linsysfs=	linsysfs
_linux=		linux
_mse=		mse
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_mlx4=		mlx4
_mlx4ib=	mlx4ib
_mlxen=		mlxen
_mthca=		mthca
.endif
_mlx5=		mlx5
.if (${MK_INET_SUPPORT} != "no" && ${MK_INET6_SUPPORT} != "no") || \
	defined(ALL_MODULES)
_mlx5en=	mlx5en
.endif
_ncv=		ncv
_ndis=		ndis
_nsp=		nsp
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
_pccard=	pccard
_pcfclock=	pcfclock
_pst=		pst
_rdma=		rdma
_safe=		safe
_sbni=		sbni
_scsi_low=	scsi_low
_smbfs=		smbfs
_sound=		sound
_speaker=	speaker
_splash=	splash
_sppp=		sppp
_stg=		stg
_streams=	streams
_svr4=		svr4
_vxge=  	vxge
_wbwd=		wbwd
_wi=		wi
_xe=		xe
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.if ${MACHINE} == "i386"
_aac=		aac
_aacraid=	aacraid
_acpi=		acpi
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_aesni=		aesni
.endif
_ahb=		ahb
_amdsbwd=	amdsbwd
_amdtemp=	amdtemp
_arcmsr=	arcmsr
_asmc=		asmc
_asr=		asr
_bios=		bios
_ciss=		ciss
_cm=		cm
_cmx=		cmx
_coretemp=	coretemp
.if ${MK_SOURCELESS_UCODE} != "no"
_ctau=		ctau
.endif
_dpt=		dpt
_ex=		ex
.if ${MK_SOURCELESS_HOST} != "no"
_hpt27xx=	hpt27xx
.endif
_hptiop=	hptiop
.if ${MK_SOURCELESS_HOST} != "no"
_hptmv=		hptmv
_hptnr=		hptnr
_hptrr=		hptrr
.endif
_hyperv=	hyperv
_ichwd=		ichwd
_ida=		ida
_iir=		iir
_ipmi=		ipmi
_ips=		ips
_ipw=		ipw
.if ${MK_SOURCELESS_UCODE} != "no"
_ipwfw=		ipwfw
.endif
_isci=		isci
_iwi=		iwi
.if ${MK_SOURCELESS_UCODE} != "no"
_iwifw=		iwifw
.endif
_iwn=		iwn
.if ${MK_SOURCELESS_UCODE} != "no"
_iwnfw=		iwnfw
.endif
_ix=		ix
_ixv=		ixv
_ixgb=		ixgb
_ixgbe=		ixgbe
_mly=		mly
_nfe=		nfe
_nvd=		nvd
.if ${MK_SOURCELESS_HOST} != "no"
_nve=		nve
.endif
_nvme=		nvme
_nvram=		nvram
_nxge=		nxge
_tpm=		tpm
_viawd=		viawd
_wpi=		wpi
.if ${MK_SOURCELESS_UCODE} != "no"
_wpifw=		wpifw
.endif
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_padlock=	padlock
.endif
_s3=		s3
_twa=		twa
_vesa=		vesa
_virtio=	virtio
_x86bios=	x86bios
.elif ${MACHINE} == "pc98"
_canbepm=	canbepm
_canbus=	canbus
_ct=		ct
_pmc=		pmc
_snc=		snc
.endif
.endif

.if ${MACHINE_CPUARCH} == "amd64"
_aac=		aac
_aacraid=	aacraid
_aout=		aout
_acpi=		acpi
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_aesni=		aesni
.endif
_agp=		agp
_an=		an
_amdsbwd=	amdsbwd
_amdtemp=	amdtemp
_arcmsr=	arcmsr
_asmc=		asmc
_bktr=		bktr
_bxe=		bxe
_cardbus=	cardbus
_cbb=		cbb
_cmx=		cmx
_ciss=		ciss
_coretemp=	coretemp
_cpuctl=	cpuctl
_cpufreq=	cpufreq
_dpms=		dpms
_drm=		drm
_drm2=		drm2
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_dtrace=	dtrace
.endif
_ed=		ed
_et=		et
_em=		em
_exca=		exca
_ext2fs=	ext2fs
.if ${MK_SOURCELESS_HOST} != "no"
_hpt27xx=	hpt27xx
.endif
_hptiop=	hptiop
.if ${MK_SOURCELESS_HOST} != "no"
_hptmv=		hptmv
_hptnr=		hptnr
_hptrr=		hptrr
.endif
_hyperv=	hyperv
_i2c=		i2c
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ibcore=        ibcore
.endif
_ichwd=		ichwd
_ida=		ida
_if_ndis=	if_ndis
_igb=		igb
_iir=		iir
_io=		io
_ipmi=		ipmi
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_ipoib=         ipoib
.endif
_ips=		ips
_ipw=		ipw
.if ${MK_SOURCELESS_UCODE} != "no"
_ipwfw=		ipwfw
.endif
_isci=		isci
_iwi=		iwi
.if ${MK_SOURCELESS_UCODE} != "no"
_iwifw=		iwifw
.endif
_iwn=		iwn
.if ${MK_SOURCELESS_UCODE} != "no"
_iwnfw=		iwnfw
.endif
_ix=		ix
_ixv=		ixv
_ixgb=		ixgb
_ixgbe=		ixgbe
_ixl=		ixl
_ixlv=		ixlv
_lindev=	lindev
_linprocfs=	linprocfs
_linsysfs=	linsysfs
_linux=		linux
_linux64=	linux64
_linux_common=	linux_common
_mly=		mly
.if ${MK_OFED} != "no" || defined(ALL_MODULES)
_mlx4=		mlx4
_mlx4ib=	mlx4ib
_mlxen=		mlxen
_mthca=		mthca
.endif
_mlx5=		mlx5
.if (${MK_INET_SUPPORT} != "no" && ${MK_INET6_SUPPORT} != "no") || \
	defined(ALL_MODULES)
_mlx5en=	mlx5en
.endif
_ndis=		ndis
_nfe=		nfe
_ntb=		ntb
_nvd=		nvd
.if ${MK_SOURCELESS_HOST} != "no"
_nve=		nve
.endif
_nvme=		nvme
_nvram=		nvram
_nxge=		nxge
.if ${MK_CDDL} != "no" || defined(ALL_MODULES)
_opensolaris=	opensolaris
.endif
.if ${MK_CRYPT} != "no" || defined(ALL_MODULES)
_padlock=	padlock
.endif
_pccard=	pccard
_pms=		pms
_qlxge=		qlxge
_qlxgb=		qlxgb
_qlxgbe=	qlxgbe
_rdma=		rdma
_s3=		s3
_safe=		safe
_scsi_low=	scsi_low
_sfxge=		sfxge
_smbfs=		smbfs
_sound=		sound
_speaker=	speaker
_splash=	splash
_sppp=		sppp
_tpm=		tpm
_twa=		twa
_vesa=		vesa
_viawd=		viawd
_virtio=	virtio
.if ${MK_BHYVE} != "no" || defined(ALL_MODULES)
_vmm=		vmm
.endif
_vxge=  	vxge
_x86bios=	x86bios
_wbwd=		wbwd
_wi=		wi
_wpi=		wpi
.if ${MK_SOURCELESS_UCODE} != "no"
_wpifw=		wpifw
.endif
.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
_zfs=		zfs
.endif
.endif

.if ${MACHINE_CPUARCH} == "arm"
_cfi=		cfi
_cpsw=		cpsw
.endif

.if ${MACHINE_CPUARCH} == "ia64"

=== sys/amd64/conf/Makefile ===
# $FreeBSD$

TARGET=amd64

.include "${.CURDIR}/../../conf/makeLINT.mk"

=== sys/amd64/linux/Makefile ===
# Makefile for syscall tables
#
# $FreeBSD$

all:
	@echo "make sysent only"

sysent:  linux_sysent.c linux_syscall.h linux_proto.h linux_syscalls.c linux_systrace_args.c

linux_sysent.c linux_syscall.h linux_proto.h linux_syscalls.c linux_systrace_args.c: \
		../../kern/makesyscalls.sh syscalls.master syscalls.conf
	-mv -f linux_sysent.c linux_sysent.c.bak
	-mv -f linux_syscall.h linux_syscall.h.bak
	-mv -f linux_proto.h linux_proto.h.bak
	-mv -f linux_syscalls.c linux_syscalls.c.bak
	-mv -f linux_systrace_args.c linux_systrace_args.c.bak
	sh ../../kern/makesyscalls.sh syscalls.master syscalls.conf

=== sys/boot/efi/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

# In-tree GCC does not support __attribute__((ms_abi)).
.if ${COMPILER_TYPE} != "gcc"

.if ${MACHINE_CPUARCH} == "amd64"
SUBDIR+=	libefi loader boot1
.endif

.endif # ${COMPILER_TYPE} != "gcc"

.if ${MACHINE_CPUARCH} == "ia64"
SUBDIR+=	libefi
.endif

.include <bsd.subdir.mk>

=== sys/boot/fdt/Makefile ===
# $FreeBSD$

.PATH:		${.CURDIR}/../../contrib/libfdt/

LIB=		fdt
INTERNALLIB=

# Vendor sources of libfdt.
SRCS+=		fdt.c fdt_ro.c fdt_wip.c fdt_sw.c fdt_rw.c fdt_strerror.c

# Loader's fdt commands extension sources.
SRCS+=		fdt_loader_cmd.c

CFLAGS+=	-I${.CURDIR}/../../contrib/libfdt/ -I${.CURDIR}/../common/

CFLAGS+=	-ffreestanding

.if ${MACHINE_CPUARCH} == "powerpc" || ${MACHINE_CPUARCH} == "arm"
CFLAGS+=	-msoft-float
.endif

.if ${MACHINE_ARCH} == "powerpc64"
CFLAGS+=	-m32
.endif

CFLAGS+=	-Wformat -Wall

.include <bsd.lib.mk>

=== sys/boot/ficl/Makefile ===
# $FreeBSD$
#

FICLDIR?=	${.CURDIR}

.if defined(FICL32)
.PATH: ${FICLDIR}/${MACHINE_CPUARCH:S/amd64/i386/}
.else
.PATH: ${FICLDIR}/${MACHINE_CPUARCH}
.endif
BASE_SRCS=	dict.c ficl.c fileaccess.c float.c loader.c math64.c \
		prefix.c search.c stack.c tools.c vm.c words.c

SRCS=		${BASE_SRCS} sysdep.c softcore.c
CLEANFILES=	softcore.c testmain testmain.o
CFLAGS+=	-ffreestanding
.if ${MACHINE_CPUARCH} == "i386" || \
    (${MACHINE_CPUARCH} == "amd64" && defined(FICL32))
CFLAGS+=	-march=i386
CFLAGS.gcc+=	-mpreferred-stack-boundary=2
.endif
.if ${MACHINE_CPUARCH} == "amd64"
CFLAGS+=	-mno-red-zone
.endif
.if ${MACHINE_CPUARCH} == "i386" || ${MACHINE_CPUARCH} == "amd64"
CFLAGS+=	-mno-mmx -mno-3dnow -mno-sse -mno-sse2 -mno-sse3 -msoft-float
.endif
.if ${MACHINE_CPUARCH} == "powerpc" || ${MACHINE_CPUARCH} == "arm"
CFLAGS+=	-msoft-float
.endif
.if ${MACHINE} == "pc98"
CFLAGS+=	-Os -DPC98
.endif
.if HAVE_PNP
CFLAGS+=	-DHAVE_PNP
.endif
.ifmake testmain
CFLAGS+=	-DTESTMAIN -D_TESTMAIN
SRCS+=		testmain.c
PROG=		testmain
.include <bsd.prog.mk>
.else
LIB=		ficl
INTERNALLIB=
.include <bsd.lib.mk>
.endif

# Standard softwords
.PATH: ${FICLDIR}/softwords
SOFTWORDS=	softcore.fr jhlocal.fr marker.fr freebsd.fr ficllocal.fr \
		ifbrack.fr
# Optional OO extension softwords
#SOFTWORDS+=	oo.fr classes.fr

.if ${MACHINE_CPUARCH} == "amd64"
.if defined(FICL32)
CFLAGS+=	-m32 -I.
.else
CFLAGS+=	-fPIC
.endif
.endif

.if ${MACHINE_ARCH} == "powerpc64"
CFLAGS+=	-m32 -mcpu=powerpc -I.
.endif

.if ${MACHINE_CPUARCH} == "amd64" && defined(FICL32)
FICL_CPUARCH=	i386
.else
FICL_CPUARCH=	${MACHINE_CPUARCH}
.endif

CFLAGS+=	-I${FICLDIR} -I${FICLDIR}/${FICL_CPUARCH} \
		-I${FICLDIR}/../common

softcore.c: ${SOFTWORDS} softcore.awk
	(cd ${FICLDIR}/softwords; cat ${SOFTWORDS} \
	    | awk -f softcore.awk -v datestamp="`LC_ALL=C date`") > ${.TARGET}

.if ${MACHINE_CPUARCH} == "amd64" && defined(FICL32)
.if !exists(machine)
${SRCS:M*.c:R:S/$/.o/g}: machine

beforedepend ${OBJS}: machine
.endif

machine:
	ln -sf ${.CURDIR}/../../i386/include machine

CLEANFILES+=	machine
.endif

=== sys/boot/ficl32/Makefile ===
# $FreeBSD$

FICL32=
FICLDIR=	${.CURDIR}/../ficl

.PATH:	${FICLDIR}

.include "${FICLDIR}/Makefile"

=== sys/boot/forth/Makefile ===
# $FreeBSD$

MAN+=	beastie.4th.8 \
	brand.4th.8 \
	check-password.4th.8 \
	color.4th.8 \
	delay.4th.8 \
	loader.conf.5 \
	loader.4th.8 \
	menu.4th.8 \
	menusets.4th.8 \
	version.4th.8

.include <bsd.prog.mk>

=== sys/boot/i386/Makefile ===
# $FreeBSD$

.include <bsd.own.mk>

SUBDIR=		mbr pmbr boot0 boot0sio btx boot2 cdboot gptboot kgzldr \
		libi386 libfirewire loader

# special boot programs, 'self-extracting boot2+loader'
SUBDIR+=	pxeldr

.if ${MK_ZFS} != "no"
SUBDIR+=	zfsboot gptzfsboot zfsloader
.endif

.include <bsd.subdir.mk>

=== sys/boot/ia64/Makefile ===
# $FreeBSD$

SUBDIR= common efi

# In the ski sub-directory, one can build a loader for use under Ski.
# Ski is an Itanium simulator, originally developed by HP. It's not
# supported anymore in FreeBSD, but left for reference and education.
# SUBDIR += ski

.include <bsd.subdir.mk>

=== debian/changelog ===
kfreebsd-10 (10.3~svn300087-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 14:01:23 +0800

kfreebsd-10 (10.3~svn300087-5) unstable; urgency=medium

  * divmoddi4.diff: New patch to fix i386 builds with newer GCC

 -- James Clarke <jrtc27@debian.org>  Sat, 02 Feb 2019 17:10:51 +0000

kfreebsd-10 (10.3~svn300087-4) unstable; urgency=medium

  [ Steven Chamberlain ]
  * Update Vcs-Browser and Vcs-Git fields
  * Ignore debian/control in Git
  * Ignore kernel-versions files in Git
  * Update my email address in Uploaders

  [ James Clarke ]
  * Backport packaging changes from kfreebsd-11:
    - Fix building with a PIE-by-default compiler
    - Move Debian-specific .gitignore to debian/
    - Enable and fix stack smashing protection
    - Backport upstream support for R_X86_64_PLT32
    - Bump compat to 11
    - Add myself to uploaders
    - Add debian/gbp.conf
    - Clamp orig tarball timestamps based on upstream revision date
    - Add lintian override for sys/kgssapi/gssapi.h
  * Bump GCC version to 8 (Closes: #892398)

 -- James Clarke <jrtc27@debian.org>  Tue, 22 Jan 2019 14:15:46 +0000

kfreebsd-10 (10.3~svn300087-3) unstable; urgency=medium

  * Really build with gcc-6 (Closes: #852006);  forgot to regenerate
    debian/control in the previous upload

 -- Steven Chamberlain <stevenc@debian.org>  Fri, 20 Jan 2017 17:41:38 +0000

kfreebsd-10 (10.3~svn300087-2) unstable; urgency=medium

  * In postinst, call update-notifier/notify-reboot-required
    (thanks, Jon Boden!) (Closes: #827072)
  * Build with gcc-6 (Closes: #835950)
  * Prefer using flex over flex-old

 -- Steven Chamberlain <stevenc@debian.org>  Mon, 09 Jan 2017 14:22:03 +0000

kfreebsd-10 (10.3~svn300087-1) unstable; urgency=medium

  * Upload to unstable
  * Avoid FTBFS due to incompatibility of `date -r`, when
    SOURCE_DATE_EPOCH is exported in the environment.

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 28 May 2016 11:02:34 +0100

kfreebsd-10 (10.3~svn300087-1~debug1) experimental; urgency=medium

  * Pick SVN r300087 from FreeBSD 10.3-RELEASE to fix:
    - EN-16:07: Excessive latency in x86 IPI delivery.
    - EN-16:08: Memory leak in ZFS.
    - SA-16:18: Buffer overflow in keyboard driver (CVE-2016-1886)
    - SA-16:19: Incorrect argument handling in sendmsg(2) (CVE-2016-1887)

 -- Steven Chamberlain <steven@pyro.eu.org>  Wed, 04 May 2016 17:30:02 +0100

kfreebsd-10 (10.3~svn297264-1~debug1) experimental; urgency=medium

  * New upstream snapshot of 10.3-RELEASE
  * Simplify the procedure to enable debug builds in debian/rules,
    enabled by putting ~debug in the Version field
  * Simplify the procedure to build with non-free drivers and blobs,
    enabled by putting +nonfree or +sourceless in the Version field
    (Thanks, Jon Boden, for the original patch this is based on)
    (Closes: #820151)
  * Relocate /lib/modules/ into /boot/, so that GRUB can load kernel
    modules even if /lib is on an unsupported or encrypted filesystem

 -- Steven Chamberlain <steven@pyro.eu.org>  Sun, 10 Apr 2016 14:57:50 +0100

kfreebsd-10 (10.3~svn296998-2) experimental; urgency=medium

  [ Steven Chamberlain ]
  * Experimentally build all arches with GCC for now (Closes: #813727)
  * Disable Stack Smashing Protection when building with GCC
    (see #819754)
  * Prevent improper #include of mm_malloc.h by GCC headers

  [ Christoph Egger ]
  * Also install zlib lintian override for zfs.ko

 -- Steven Chamberlain <steven@pyro.eu.org>  Fri, 01 Apr 2016 22:24:32 +0100

kfreebsd-10 (10.3~svn296998-1) experimental; urgency=medium

  * New upstream snapshot of 10.3-RC3:
    - SA-16:15: Fix incorrect argument validation in sysarch(2).
      (CVE-2016-1885) (Closes: #818426)
  * Amend svn_revision regex to support local suffixes
    (Thanks, Jon Boden) (Closes: #818700)
  * On arches that don't use Clang, Build-Depend on gcc-5
    rather than gcc-4.9 (Closes: #818777)

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 19 Mar 2016 20:49:47 +0000

kfreebsd-10 (10.3~svn296373-2) experimental; urgency=medium

  * Directly declare Build-Depends: freebsd-mk (>= 10.3~), since
    freebsd-glue dropped this build-dependency, and new MK knobs in
    10.3 are needed.
  * Re-enable debugging options:
    - 999_config.diff
  * Enable redzone(9) heap-smashing detection for debug builds only.
  * Enable Stack-Smashing Protection (disable it only when building the
    aic7xxx firmware toolchain).

 -- Steven Chamberlain <steven@pyro.eu.org>  Fri, 11 Mar 2016 11:39:19 +0000

kfreebsd-10 (10.3~svn296373-1) experimental; urgency=medium

  * New upstream snapshot of 10.3-RC1
  * Make get-orig-source tarball reproducible
  * Replace BUILD_DATE with SOURCE_DATE_EPOCH
  * Refresh patches:
    - userland.diff
    - 004_xargs.diff
    - 902_version.diff
    - 904_dev_full.diff
    - 908_linprocfs_is_not_proc.diff
    - 920_linux_cflags.diff
    - 921_signal_watchdog.diff
    - 922_cc_version.diff
    - 923_newvers_timestamp.diff
  * Bump Build-Depends: freebsd-buildutils to (>= 10.3~)

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 06 Feb 2016 16:23:08 +0000

kfreebsd-10 (10.2-1) experimental; urgency=medium

  * New upstream release (10.2)
  * Drop backported patches
  * Refresh th others
  * Require freebsd-buildutils 10.2

 -- Christoph Egger <christoph@debian.org>  Fri, 21 Aug 2015 13:29:45 +0200

kfreebsd-10 (10.1~svn274115-10) unstable; urgency=high

  [ Christoph Egger ]
  * Make kfreebsd-source multi-arch foreign

  [ Steven Chamberlain ]
  * Pick SVN r287146 from FreeBSD 10.1-RELEASE:
    - SA-15:21: Fix local privilege escalation in IRET handler.
      (CVE-2015-5675) (Closes: #796996)
    - EN-15:14: Disabled ixgbe(4) flow-director support, due to an 
      implementation bug.

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 22 Aug 2015 00:58:41 +0100

kfreebsd-10 (10.1~svn274115-9) unstable; urgency=medium



=== debian/control ===
Source: kfreebsd-10
Section: kernel
Priority: optional
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders:
 Aurelien Jarno <aurel32@debian.org>,
 Robert Millan <rmh@debian.org>,
 Christoph Egger <christoph@debian.org>,
 Steven Chamberlain <stevenc@debian.org>,
 James Clarke <jrtc27@debian.org>,
Build-Depends:
 debhelper (>= 11~),
 bzip2,
 sharutils,
 flex | flex-old,
 freebsd-buildutils (>= 10.3~),
 freebsd-glue (>= 0.2.20~),
 freebsd-mk (>= 10.3~),
 byacc,
 gcc-8,
 libdb-dev,
 libbsd-dev (>= 0.3.0),
 pkg-config,
 libsbuf-dev (>= 9.0+ds1-2),
 kernel-wedge (>= 2.79) [kfreebsd-any],
Standards-Version: 3.9.2
Vcs-Browser: https://salsa.debian.org/bsd-team/kfreebsd-10
Vcs-Git: https://salsa.debian.org/bsd-team/kfreebsd-10.git

Package: kfreebsd-source-10.3
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: freebsd-buildutils (>= 7)
Provides: kfreebsd-source-10, kfreebsd-source
Description: source code for kernel of FreeBSD 10.3 with Debian patches
 This package provides the source code for kernel of FreeBSD 10.3, base of
 a GNU/kFreeBSD system.

Package: kfreebsd-headers-10.3-0
Architecture: kfreebsd-any
Depends: ${misc:Depends}
Description: Common architecture-specific header files for kernel of FreeBSD 10.3
 This package provides the architecture-specific common kernel header files for
 kernel of FreeBSD 10.3, generally used for building out-of-tree kernel
 modules. To obtain a complete set of headers you also need to install the
 kfreebsd-headers-10.3-0-(flavour) package, matching the flavour of the
 kernel you intend the build for. To obtain such a set for the currently running
 kernel it is sufficient to run a command
 .
 apt-get install kfreebsd-headers-$(uname -r)
 .
 and it will be unpacked in /usr/src/kfreebsd-headers-10.3-0-(flavour)


Package: kfreebsd-image-10.3-0-amd64
Architecture: kfreebsd-amd64
Depends: ${misc:Depends},
 freebsd-utils (>= 8.1-5) [kfreebsd-any], kldutils (>= 7.1) [kfreebsd-any],
 devd [kfreebsd-any] | freebsd-utils (<< 8.2+ds2-9) [kfreebsd-any],
# Policy-conformant keyboard mappings (see #605777)
 kbdcontrol (>= 8.2+ds2-6) [kfreebsd-any],
Conflicts: kfreebsd-loader (<< 5.4-1.3)
Breaks:
# ZFS metadata now compressed with LZ4 by default;  requires recent GRUB
 grub-common (<< 2.02~) [kfreebsd-any],
# AT_* macros break LD_PRELOAD (see #630695)
# Missing support for RFTSIGZMB (see 007_clone_signals.diff)
 libc0.1 (<< 2.11.3-1) [kfreebsd-any],
# Require ZFS v28 userland
 zfsutils (<< 8.3~) [kfreebsd-any],
# ABI changes since kFreeBSD 9.0
 freebsd-net-tools (<< 10.0~) [kfreebsd-any],
 freebsd-smbfs (<< 10.0~) [kfreebsd-any],
 pf (<< 10.1~) [kfreebsd-any],
Provides: kfreebsd-image-10, kfreebsd-image
Recommends: 
Description: kernel of FreeBSD 10.3 image
 This package provides the binary image and pre-built loadable modules for
 the kernel of FreeBSD 10.3, base of a GNU/kFreeBSD system.
 .
 This package is compiled for a amd64-class machine.

Package: kfreebsd-image-10-amd64
Architecture: kfreebsd-amd64
Depends: kfreebsd-image-10.3-0-amd64, ${misc:Depends}
Description: kernel of FreeBSD 10 image (meta-package)
 This package depends on the latest binary image for kernel of FreeBSD 10 on
 amd64-class machines.

Package: kfreebsd-headers-10.3-0-amd64
Architecture: kfreebsd-amd64
Provides: kfreebsd-headers-10, kfreebsd-headers
Depends: kfreebsd-headers-10.3-0 (= ${binary:Version}), ${misc:Depends}
Description: header files for kernel of FreeBSD 10.3
 This package provides the header files for kernel of FreeBSD 10.3, generally
 used for building out-of-tree kernel modules. These files are going to be
 installed into /usr/src/kfreebsd-headers-10.3-0-amd64, and can be
 used for building modules that load into the kernel provided by the
 kfreebsd-image-10.3-0-amd64 package.

Package: kfreebsd-headers-10-amd64
Architecture: kfreebsd-amd64
Depends: kfreebsd-headers-10.3-0-amd64, ${misc:Depends}
Description: header files for kernel of FreeBSD 10 (meta-package)
 This package depends on the latest header files for kernel of FreeBSD 10 on
 amd64-class machines.


Package: kernel-image-10.3-0-amd64-di
Package-Type: udeb
Provides: kernel-image, ata-modules, cdrom-core-modules, core-modules, crc-modules, ext2-modules, ide-core-modules, ide-modules, input-modules, mmc-core-modules, mouse-modules, nic-pcmcia-modules, nls-core-modules, pata-modules, pcmcia-modules, pcmcia-storage-modules, rtc-modules, scsi-common-modules, serial-modules, ufs-modules, uinput-modules, usb-modules, usb-storage-modules
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: extra
Description: kFreeBSD binary image for the Debian installer
 This package contains the kernel of FreeBSD for the Debian installer
 boot images. It does _not_ provide a usable kernel for your full
 Debian system.

Package: nic-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: nic-modules
Depends: kernel-image-10.3-0-amd64-di, nic-shared-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Common NIC drivers
 This package contains common NIC drivers for the kernel.

Package: nic-wireless-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: nic-wireless-modules
Depends: kernel-image-10.3-0-amd64-di, nic-shared-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Wireless NIC drivers
 This package contains wireless NIC drivers for the kernel.
 Includes crypto modules only needed for wireless (WEP).

Package: nic-shared-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: nic-shared-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Shared NIC drivers
 This package contains NIC drivers needed by combinations of nic-modules,
 nic-extra-modules, nic-pcmcia-modules, and nic-wireless-modules.

Package: serial-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: serial-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: optional
Description: Serial drivers
 This package contains serial drivers for the kernel.

Package: usb-serial-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: usb-serial-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: optional
Description: USB serial drivers
 This package contains USB serial drivers for the kernel.

Package: ppp-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: ppp-modules
Depends: kernel-image-10.3-0-amd64-di, serial-modules-10.3-0-amd64-di, zlib-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: optional
Description: PPP drivers
 This package contains PPP drivers for the kernel.

Package: cdrom-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: cdrom-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: optional
Description: Esoteric CDROM drivers
 This package contains esoteric CDROM drivers for the kernel.

Package: scsi-core-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: scsi-core-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Core SCSI subsystem
 This package contains the core SCSI subsystem for the kernel.

Package: scsi-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: scsi-modules
Depends: kernel-image-10.3-0-amd64-di, scsi-core-modules-10.3-0-amd64-di, parport-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: SCSI drivers
 This package contains SCSI drivers for the kernel.

Package: scsi-extra-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: scsi-extra-modules
Depends: scsi-modules-10.3-0-amd64-di, scsi-core-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Uncommon SCSI drivers
 This package contains uncommon SCSI drivers for the kernel.
 This includes SCSI RAID drivers, and some of the less common SCSI
 controllers.

Package: plip-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: plip-modules
Depends: kernel-image-10.3-0-amd64-di, parport-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: optional
Description: PLIP drivers
 This package contains PLIP drivers for the kernel.

Package: floppy-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: floppy-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Floppy driver
 This package contains the floppy driver for the kernel.

Package: loop-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: loop-modules
Depends: kernel-image-10.3-0-amd64-di, zlib-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: Loopback filesystem support
 This package contains loopback filesystem support for the kernel.

Package: ipv6-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: ipv6-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: extra
Description: IPv6 driver
 This package contains the IPv6 driver for the kernel.

Package: nls-core-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: nls-core-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: extra
Description: Core NLS support
 This package contains basic NLS support modules for the kernel.

Package: ext2-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: ext2-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: EXT2 filesystem support
 This package contains the EXT2 filesystem module for the kernel.

Package: isofs-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: isofs-modules
Depends: kernel-image-10.3-0-amd64-di, nls-core-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: standard
Description: ISOFS filesystem support
 This package contains the ISOFS filesystem module for the kernel.

Package: reiserfs-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: reiserfs-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: extra
Description: Reiser filesystem support
 This package contains the Reiser filesystem module for the kernel.

Package: fat-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: fat-modules
Depends: kernel-image-10.3-0-amd64-di, nls-core-modules-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: extra
Description: FAT filesystem support
 This package contains the FAT and VFAT filesystem modules for the kernel.

Package: zfs-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: zfs-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64
Section: debian-installer
Priority: extra
Description: ZFS filesystem support
 This package contains the ZFS filesystem module for the kernel.

Package: nfs-modules-10.3-0-amd64-di
Package-Type: udeb
Provides: nfs-modules
Depends: kernel-image-10.3-0-amd64-di
Architecture: kfreebsd-amd64
Kernel-Version: 10.3-0-amd64

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

SHELL = bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_OS	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_ARCH_CPU	?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

source		:= $(shell dpkg-parsechangelog | grep ^Source: | sed -e 's/^.*: //g')
full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
tar_version	:= $(shell echo $(full_version) | sed -e 's/-.*//g')
svn_revision	:= $(shell echo $(full_version) | sed -e 's/.*~svn\([0-9]*\)-[0-9]\+.*/\1/g' -e 's/^$(full_version)$$/HEAD/g')
version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
major           := $(shell echo $(version) | sed -e 's/\..*//g')
revision	:= $(shell echo $(full_version) | sed -e 's/^[^+-]*//g')
cpu		:= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
config_files	:= $(wildcard debian/arch/$(cpu)/*.config)
flavours	:= $(config_files:debian/arch/$(cpu)/%.config=%)
ld_target	:= $(shell ld --help | sed -ne "s/[^ :]*: supported targets: \([^ ]*\) .*/\1/p")
configfile	:= DEBCUSTOM

# Whether to enable extra debug features, at the expense of performance
# Not recommended for release builds
debug		:= no
# Putting ~debug in the Version field enbles this automatically
ifneq ($(findstring ~debug,$(full_version)),)
debug		:= yes
endif

# Produce a DFSG-free package by default, stripping out sourceless
# (non-free) blobs.  Put +nonfree or +sourceless in the Version field
# to keep the non-free parts and build non-free drivers
nonfree		:= $(findstring +nonfree,$(full_version))$(findstring +sourceless,$(full_version))

abiname		:= 0
# Clearly indicate if the build is non-free, and make it
# co-installable with DFSG-free versions
abiname		:= $(abiname)$(nonfree)

ifeq ($(cpu), mipsel)
kfreebsd_cpu	:= mips
else
kfreebsd_cpu	:= $(cpu)
endif

SVN_BASE	:= https://svn.freebsd.org/base
#SVN		:= $(SVN_BASE)/release/$(version).0
SVN		:= $(SVN_BASE)/releng/$(version)
#SVN		:= $(SVN_BASE)/stable/$(major)
#SVN		:= $(SVN_BASE)/head

SOURCE_PACKAGE	:= $(CURDIR)/debian/kfreebsd-source-$(version)
IMAGE_PACKAGE	:= $(CURDIR)/debian/kfreebsd-image-$(version)-$(abiname)
HEADERS_PACKAGE	:= $(CURDIR)/debian/kfreebsd-headers-$(version)-$(abiname)
SRC_TAR		:= kfreebsd-source-$(version).tar.xz
SRC_DIR		:= kfreebsd-source-$(version)
HEADERS_DIR	:= kfreebsd-headers-$(version)-$(abiname)
FLAVOR_DIR	:= flavor-$(version)-$(abiname)
ORIG_DIR	:= $(source)-$(tar_version)
ORIG_TAR	:= $(source)_$(tar_version).orig.tar.xz
PATH		:= /usr/lib/freebsd:$(PATH)
SOURCE_DATE_EPOCH ?= $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

	# Do not mess with MAKEFLAGS until we transfer control to BSD make (see below)
	BSD_MAKEFLAGS += -j$(NUMJOBS)
endif

MAKE		:= \
		MAKEFLAGS=$(BSD_MAKEFLAGS) \
		make \
		MACHINE_ARCH=$(kfreebsd_cpu)

ifeq ($(nonfree),)
# Disable non-free drivers
MAKE		+= -DWITHOUT_SOURCELESS
endif

# Clang is the default compiler on these architectures (see src/share/mk/bsd.own.mk)
clang_cpus	:= # i386 amd64 arm
# Experimentally build all arches with GCC for now
cc_pkg		:= gcc-8

#cc_pkg		:= clang-3.5 [$(foreach cpu,$(clang_cpus),any-$(cpu))], \
#		gcc-6 [$(foreach cpu,$(clang_cpus),!any-$(cpu))]

ifneq (, $(filter $(clang_cpus), $(DEB_HOST_ARCH_CPU)))
cc_cmd		:= clang-3.5
else
cc_cmd		:= gcc-8
endif

ifeq ($(cc_cmd), clang)
MAKE	+= -DWITH_CLANG_IS_CC
else
MAKE	+= -DWITHOUT_CLANG_IS_CC
MAKE	+= WERROR=
endif

MAKE += -DWITHOUT_CTF

# Disable install of *.ko.symbols files (their presence would trigger an
# "unstripped-binary-or-object" lintian error).
MAKE += -DWITHOUT_KERNEL_SYMBOLS	

# Prevent improper #include of mm_malloc.h by GCC headers
CFLAGS += -D_MM_MALLOC_H_INCLUDED

get-orig-source:
	rm -rf $(ORIG_DIR)
	svn export --ignore-keywords -r $(svn_revision) $(SVN)/sys $(ORIG_DIR)/sys
ifeq ($(nonfree),)
	# Removing non-free blobs to make source package DFSG-free
	cd $(ORIG_DIR) && $(CURDIR)/debian/prune.sh
	# Replace file with a DFSG-free re-implementation
	cp -af debian/local/ar9300_devid.h $(ORIG_DIR)/sys/contrib/dev/ath/ath_hal/ar9300/
	cp -af debian/local/ar9300_devid.h $(ORIG_DIR)/sys/dev/ath/ath_hal/ar9003/
else
	# WARNING: orig source tarball will contain non-free blobs
endif
	# Clamp timestamps to be no newer than last upstream revision, see
	# https://wiki.debian.org/ReproducibleBuilds/TimestampsInTarball
	REVISION_DATE_EPOCH=`date -d \`svn info -r $(svn_revision) $(SVN)/sys \
	  --show-item last-changed-date\` +%s` && \
	find $(ORIG_DIR) -newermt "@$$REVISION_DATE_EPOCH" -print0 \
	 | xargs -0r touch --no-dereference --date="@$$REVISION_DATE_EPOCH"
	# Create tarball with files sorted in a stable order, see
	# https://wiki.debian.org/ReproducibleBuilds/FileOrderInTarballs
	find $(ORIG_DIR) -print0 | LC_ALL=C sort -z \
	 | tar --null --no-recursion --files-from - \
	    --numeric-owner --owner 0 --group 0 \
	    -cJf ../$(ORIG_TAR)
	rm -rf $(ORIG_DIR)

control: clean
	for arch in `ls $(CURDIR)/debian/arch/` ; do \
		KW_CONFIG_DIR=debian/installer/$$arch ; \
		if test -e $$KW_CONFIG_DIR ; then \
			for config in `ls $(CURDIR)/debian/arch/$$arch/ | grep \.config` ; do \
				flavor=$${config/.config/} ; \
				if test -e debian/arch/$$arch/$$flavor.installer ; then \
					echo "kfreebsd-$$arch $(version)-$(abiname) $$flavor $(version)-$(abiname)-$$flavor - -" ; \
				fi ; \
			done > $$KW_CONFIG_DIR/kernel-versions ; \
		fi ; \
		echo ; \
	done
	sed -e "s/@major@/$(major)/g" -e "s/@version@/$(version)/g" -e "s/@abiname@/$(abiname)/g" -e "s/@flavor@/$$flavor/g" \
		-e "s/@cc_pkg@/$(cc_pkg)/g" \
		$(CURDIR)/debian/control.in > $(CURDIR)/debian/control
	echo >> $(CURDIR)/debian/control
	for arch in `ls $(CURDIR)/debian/arch/` ; do \
		for config in `ls $(CURDIR)/debian/arch/$$arch/ | grep \.config` ; do \
			flavor=$${config/.config/} ; \
			recommends= ; \
			test -f $(CURDIR)/debian/arch/$$arch/$$flavor.defines && recommends=`awk '/^Recommends: / {print $$2}' $(CURDIR)/debian/arch/$$arch/$$flavor.defines` ; \
			sed -e "s/@major@/$(major)/g" -e "s/@version@/$(version)/g" -e "s/@abiname@/$(abiname)/g" -e "s/@flavor@/$$flavor/g" -e "s/@arch@/$$arch/g" -e "s/@recommends@/$$recommends/g" \
				$(CURDIR)/debian/control.flavor.in ; \
			echo ; \
		done ; \
		export KW_DEFCONFIG_DIR=debian/installer ; \
		export KW_CONFIG_DIR=debian/installer/$$arch ; \
		if test -e $$KW_CONFIG_DIR/kernel-versions ; then \
			kernel-wedge gen-control ; \
		fi ; \
		echo ; \
	done >> $(CURDIR)/debian/control

clean:
	dh_testdir
	dh_testroot
	rm -rf kfreebsd-source-* flavor-*
	rm -f debian/kfreebsd-image-*.preinst
	rm -f debian/kfreebsd-image-*.prerm
	rm -f debian/kfreebsd-image-*.postinst
	rm -f debian/kfreebsd-image-*.postrm

	dh_clean

build-indep: build-indep-stamp
build-indep-stamp:
	dh_testdir

	mkdir -p $(SRC_DIR)
	cp -af sys $(SRC_DIR)/

	touch build-indep-stamp

build: build-arch build-indep

install-indep: install-indep-stamp
install-indep-stamp: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs -i

	mkdir -p $(SOURCE_PACKAGE)/usr/src
	chown -R root.src $(SRC_DIR)
	# Clamp timestamps to be no newer than last changelog entry, see
	# https://wiki.debian.org/ReproducibleBuilds/TimestampsInTarball
	find $(SRC_DIR) -newermt "@$(SOURCE_DATE_EPOCH)" -print0 \
	 | xargs -0r touch --no-dereference --date="@$(SOURCE_DATE_EPOCH)"
	# Create tarball with files sorted in a stable order, see
	# https://wiki.debian.org/ReproducibleBuilds/FileOrderInTarballs
	# and normalised file permissions regardless of umask, see
	# https://wiki.debian.org/ReproducibleBuilds/VaryingPermissionsInTarballs
	find $(SRC_DIR) -print0 | LC_ALL=C sort -z \
	 | tar --null --no-recursion --files-from - \
	    --mode=go=rX,u+rw,a-s \
	    -cJf $(SOURCE_PACKAGE)/usr/src/$(SRC_TAR)

	touch install-indep-stamp
